=== debian/changelog ===
blaspp (2023.11.05-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Dec 2023 18:20:58 +0100

blaspp (2023.08.25-2) unstable; urgency=medium

  * debian/patches/reproducible-build.patch: New patch, making the build
    reproducible, by Chris Lamb (Closes: #1053263).

 -- Michael Banck <mbanck@debian.org>  Sat, 30 Sep 2023 16:34:16 +0200

blaspp (2023.08.25-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Tue, 12 Sep 2023 14:37:38 +0530
