## blaspp 2024.05.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,9 +15,15 @@
 
 project(
     blaspp
-    VERSION 2023.11.05
+    VERSION 2024.05.31
     LANGUAGES CXX
 )
+
+# See notes in GNUmakefile about using abi-compliance-checker.
+# soversion is major ABI version.
+set( abi_version 1.0.0 )
+string( REPLACE "." ";" abi_list "${abi_version}" )
+list( GET abi_list 0 soversion )
 
 include( CheckCXXCompilerFlag )
 
@@ -147,6 +153,8 @@
 use_openmp             = ${use_openmp}
 blaspp_is_project      = ${blaspp_is_project}
 blaspp_                = ${blaspp_}
+abi_version            = ${abi_version}
+soversion              = ${soversion}
 " )
 
 #-------------------------------------------------------------------------------
@@ -207,7 +215,9 @@
     src/trmv.cc
     src/trsm.cc
     src/trsv.cc
+    src/util.cc
     src/version.cc
+
     src/device_batch_gemm.cc
     src/device_batch_gemm_group.cc
     src/device_batch_hemm.cc
@@ -348,11 +358,3 @@
 #-------------------------------------------------------------------------------
 # Clean stale defines.h from Makefile-based build.
 message( "" )
-file( REMOVE "${CMAKE_CURRENT_SOURCE_DIR}/include/blas/defines.h" )
-
-# Include directory.
-# During build it's {source}/include; after install it's {prefix}/include.
-target_include_directories(
-    blaspp
-    PUBLIC
-        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>"  # defines.h
