=== debian/changelog ===
blaspp (2024.05.31-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sun, 30 Jun 2024 16:00:55 +0200
