## blaspp 2024.10.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 project(
     blaspp
-    VERSION 2024.05.31
+    VERSION 2024.10.26
     LANGUAGES CXX
 )
