=== debian/changelog ===
blaspp (2024.10.26-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/reproducible-build.patch: Removed, applied upstream. 

 -- Michael Banck <mbanck@debian.org>  Sun, 09 Mar 2025 18:51:43 +0100
