=== debian/control ===
Source: blaspp
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               libblas-dev
Standards-Version: 4.5.1
Homepage: https://github.com/icl-utk-edu/blaspp
Vcs-Browser: https://salsa.debian.org/debichem-team/blaspp
Vcs-Git: https://salsa.debian.org/debichem-team/blaspp.git

Package: libblaspp-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ API for the Basic Linear Algebra Subroutines (development files)
 The Basic Linear Algebra Subprograms (BLAS) have been around for many decades
 and serve as the de facto standard for performance-portable and numerically
 robust implementation of essential linear algebra functionality. Originally,
 they were written in Fortran, and later furnished with a C API (CBLAS).
 .
 The objective of BLAS++ is to provide a convenient, performance oriented API
 for development in the C++ language, that, for the most part, preserves
 established conventions, while, at the same time, takes advantages of modern
 C++ features, such as: namespaces, templates, exceptions, etc.
 .
 This package contains the static libraries and the header files.
