## blaspp 2025.05.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,23 +5,24 @@
 #
 # CMake script for BLAS++ library.
 
-cmake_minimum_required( VERSION 3.17 )
+cmake_minimum_required( VERSION 3.21 )
 # 3.1  target_compile_features
 # 3.8  target_compile_features( cxx_std_17 )
 # 3.14 install( LIBRARY DESTINATION lib ) default
 # 3.15 $<$COMPILE_LANG_AND_ID  # optional
 # 3.15 message DEBUG, string REPEAT
 # 3.17 find_package( CUDAToolkit )
+# 3.21 enable_language( HIP ) support
 
 project(
     blaspp
-    VERSION 2024.10.26
+    VERSION 2025.05.28
     LANGUAGES CXX
 )
 
 # See notes in GNUmakefile about using abi-compliance-checker.
 # soversion is major ABI version.
-set( abi_version 1.0.0 )
+set( abi_version 2.0.0 )
 string( REPLACE "." ";" abi_list "${abi_version}" )
 list( GET abi_list 0 soversion )
 
@@ -61,6 +62,7 @@
 
 # After color.
 include( "cmake/util.cmake" )
+include( "cmake/config.cmake" )
 
 # Recognize CTest's BUILD_TESTING flag. (Quotes required.)
 if (NOT "${BUILD_TESTING}" STREQUAL "")
@@ -105,8 +107,8 @@
      "BLAS library to search for" )
 set_property(
     CACHE blas PROPERTY STRINGS
-    "auto" "Apple Accelerate" "Cray LibSci" "IBM ESSL"
-    "Intel MKL" "OpenBLAS" "AMD ACML" "generic" )
+    "auto" "AMD AOCL" "Apple Accelerate" "BLIS" "Cray LibSci" "IBM ESSL"
+    "Intel MKL" "OpenBLAS" "generic" )
 
 set( blas_fortran "auto" CACHE STRING
      "For Intel MKL: use Intel ifort or GNU gfortran conventions?" )
@@ -169,6 +171,131 @@
     cd build
     cmake ..
     make" )
+endif()
+
+#-------------------------------------------------------------------------------
+# Load the CUDA language and packages.
+message( "" )
+set( blaspp_use_cuda false )  # output in blasppConfig.cmake.in
+if (gpu_backend MATCHES "^(auto|cuda)$")
+    message( STATUS "${bold}Looking for CUDA${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (gpu_backend STREQUAL "cuda")
+        find_package( CUDAToolkit REQUIRED )
+    else()
+        find_package( CUDAToolkit QUIET )
+    endif()
+    if (CUDAToolkit_FOUND)
+        set( gpu_backend "cuda" )
+        set( blaspp_defs_cuda_ "-DBLAS_HAVE_CUBLAS" )
+        set( blaspp_use_cuda true )
+
+        # Set CUDA architecture _before_ enable_language, otherwise we get some
+        # default CMake value seemingly unrelated to the native GPU, e.g., 52.
+        #
+        # See nvcc --help, in section --gpu-architecture
+        # 30  Kepler
+        # 50  Maxwell
+        # 60  Pascal
+        # 70  Volta
+        # 75  Turing
+        # 80  Ampere
+        # 90  Hopper
+        # 100 Blackwell ?
+        #
+        if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
+            set( arch "native" )
+        else()
+            set( arch "70" )  # Volta
+        endif()
+        set( CMAKE_CUDA_ARCHITECTURES "${arch}" CACHE STRING
+            "CUDA architectures, as semi-colon separated list of (mostly) 2-3 digit numbers, e.g., 60;70;80 for Pascal, Volta, Ampere" )
+        set_property( CACHE CMAKE_CUDA_ARCHITECTURES PROPERTY STRINGS
+                    native all all-major 30 50 60 70 75 80 90 )
+        enable_language(CUDA)
+        message( STATUS "${blue}Building CUDA support${plain}" )
+    else()
+        message( STATUS "${red}No CUDA support: CUDA not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping CUDA search: gpu_backend = ${gpu_backend}${plain}" )
+endif()
+
+#-------------------------------------------------------------------------------
+# Load HIP language and packages.
+message( "" )
+set( blaspp_use_hip false )  # output in blasppConfig.cmake.in
+if (NOT CUDAToolkit_FOUND
+    AND gpu_backend MATCHES "^(auto|hip)$")
+
+    message( STATUS "${bold}Looking for HIP/ROCm${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (gpu_backend STREQUAL "hip")
+        find_package( hip REQUIRED )
+        find_package( rocblas REQUIRED )
+    else()
+        find_package( rocblas QUIET )
+    endif()
+    if (rocblas_FOUND)
+        set( gpu_backend "hip" )
+        set( blaspp_defs_hip_ "-DBLAS_HAVE_ROCBLAS" )
+        set( blaspp_use_hip true )
+
+        # For ROCm >= 3.5, wipe hip-clang specific interface options which are propagated
+        set_target_properties( hip::device PROPERTIES INTERFACE_COMPILE_OPTIONS "-fPIC" )
+        set_target_properties( hip::device PROPERTIES INTERFACE_LINK_LIBRARIES "hip::host" )
+
+        enable_language( HIP )
+        message( STATUS "${blue}Building HIP/ROCm support${plain}" )
+    else()
+        message( STATUS "${red}No HIP/ROCm support: ROCm not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping HIP/ROCm search: gpu_backend = ${gpu_backend}${plain}" )
+endif()
+
+
+#-------------------------------------------------------------------------------
+# SYCL support.
+message( "" )
+set( blaspp_use_sycl false )  # output in blasppConfig.cmake.in
+# if cuda or hip were found gpu_backend was set appropriately
+if (gpu_backend MATCHES "^(auto|sycl)$")
+
+    message( STATUS "${bold}Looking for oneMKL-SYCL${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (TARGET MKL::MKL_DPCPP) # Search for MKL only if not already been found
+        set( MKL_FOUND true )
+    endif()
+    if (NOT MKL_FOUND) # Search for MKL only if not already been found
+        if (gpu_backend STREQUAL "sycl")
+            find_package( MKL CONFIG REQUIRED QUIET HINTS "$ENV{MKL_ROOT}")
+        else()
+            find_package( MKL CONFIG QUIET HINTS "$ENV{MKL_ROOT}")
+        endif()
+    endif()
+    # message(STATUS "Available targets: ${MKL_IMPORTED_TARGETS}")
+
+    # Check if compiler supports the SYCL flag
+    check_cxx_compiler_flag( "-fsycl" FSYCL_SUPPORT )
+
+    # If oneMKL is found and the compiler supports SYCL then
+    # enable oneMKL-SYCL-device support
+    if (MKL_FOUND AND FSYCL_SUPPORT)
+        set( gpu_backend "sycl" )
+        set( blaspp_defs_sycl_ "-DBLAS_HAVE_SYCL;-DBLAS_FORTRAN_ADD_" )
+        set( blaspp_use_sycl true )
+
+        # Uncomment to use CMake FindBLAS using BLA_VENDOR
+        # if (NOT BLA_VENDOR)
+        #    set( BLA_VENDOR Intel10_64lp )
+        # endif()
+
+        message( STATUS "${blue}Building oneMKL-SYCL device support${plain}" )
+    elseif (gpu_backend STREQUAL "sycl")
+        message( FATAL_ERROR "${red}SYCL compiler not found${plain}" )
+    else()
+        message( STATUS "${red}No oneMKL-SYCL device support: oneMKL or SYCL compiler not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping oneMKL-SYCL search: gpu_backend = ${gpu_backend}${plain}" )
 endif()
 
 #-------------------------------------------------------------------------------
@@ -219,142 +346,3 @@
     src/version.cc
 
     src/device_batch_gemm.cc
-    src/device_batch_gemm_group.cc
-    src/device_batch_hemm.cc
-    src/device_batch_her2k.cc
-    src/device_batch_herk.cc
-    src/device_batch_symm.cc
-    src/device_batch_syr2k.cc
-    src/device_batch_syrk.cc
-    src/device_batch_trmm.cc
-    src/device_batch_trsm.cc
-    src/device_error.cc
-    src/device_gemm.cc
-    src/device_hemm.cc
-    src/device_her2k.cc
-    src/device_herk.cc
-    src/device_queue.cc
-    src/device_symm.cc
-    src/device_syr2k.cc
-    src/device_syrk.cc
-    src/device_axpy.cc
-    src/device_dot.cc
-    src/device_nrm2.cc
-    src/device_scal.cc
-    src/device_swap.cc
-    src/device_copy.cc
-    src/device_trmm.cc
-    src/device_trsm.cc
-    src/device_utils.cc
-    src/cublas_wrappers.cc
-    src/rocblas_wrappers.cc
-    src/onemkl_wrappers.cc
-)
-
-#-------------------------------------------------------------------------------
-# CUDA support.
-message( "" )
-set( blaspp_use_cuda false )  # output in blasppConfig.cmake.in
-if (gpu_backend MATCHES "^(auto|cuda)$")
-    message( STATUS "${bold}Looking for CUDA${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (gpu_backend STREQUAL "cuda")
-        find_package( CUDAToolkit REQUIRED )
-    else()
-        find_package( CUDAToolkit QUIET )
-    endif()
-    if (CUDAToolkit_FOUND)
-        set( gpu_backend "cuda" )
-        set( blaspp_defs_cuda_ "-DBLAS_HAVE_CUBLAS" )
-        set( blaspp_use_cuda true )
-
-        # Some platforms need these to be public libraries.
-        target_link_libraries(
-            blaspp PUBLIC CUDA::cudart CUDA::cublas )
-        message( STATUS "${blue}Building CUDA support${plain}" )
-    else()
-        message( STATUS "${red}No CUDA support: CUDA not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No CUDA support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# HIP/ROCm support.
-message( "" )
-set( blaspp_use_hip false )  # output in blasppConfig.cmake.in
-if (NOT CUDAToolkit_FOUND
-    AND gpu_backend MATCHES "^(auto|hip)$")
-
-    message( STATUS "${bold}Looking for HIP/ROCm${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (gpu_backend STREQUAL "hip")
-        find_package( rocblas REQUIRED )
-    else()
-        find_package( rocblas QUIET )
-    endif()
-    if (rocblas_FOUND)
-        set( gpu_backend "hip" )
-        set( blaspp_defs_hip_ "-DBLAS_HAVE_ROCBLAS" )
-        set( blaspp_use_hip true )
-
-        # Some platforms need these to be public libraries.
-        target_link_libraries(
-            blaspp PUBLIC roc::rocblas )
-        message( STATUS "${blue}Building HIP/ROCm support${plain}" )
-    else()
-        message( STATUS "${red}No HIP/ROCm support: ROCm not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No HIP/ROCm support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# SYCL support.
-message( "" )
-set( blaspp_use_sycl false )  # output in blasppConfig.cmake.in
-# if cuda or hip were found gpu_backend was set appropriately
-if (gpu_backend MATCHES "^(sycl|auto)$")
-
-    message( STATUS "${bold}Looking for oneMKL-SYCL${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (TARGET MKL::MKL_DPCPP) # Search for MKL only if not already been found
-        set( MKL_FOUND true )
-    endif()
-    if (NOT MKL_FOUND) # Search for MKL only if not already been found
-        if (gpu_backend STREQUAL "sycl")
-            find_package( MKL CONFIG REQUIRED QUIET HINTS "$ENV{MKL_ROOT}")
-        else()
-            find_package( MKL CONFIG QUIET HINTS "$ENV{MKL_ROOT}")
-        endif()
-    endif()
-    # message(STATUS "Available targets: ${MKL_IMPORTED_TARGETS}")
-
-    # Check if compiler supports the SYCL flag
-    check_cxx_compiler_flag( "-fsycl" FSYCL_SUPPORT )
-
-    # If oneMKL is found and the compiler supports SYCL then
-    # enable oneMKL-SYCL-device support
-    if (MKL_FOUND AND FSYCL_SUPPORT)
-        set( gpu_backend "sycl" )
-        set( blaspp_defs_sycl_ "-DBLAS_HAVE_SYCL;-DBLAS_FORTRAN_ADD_" )
-        set( blaspp_use_sycl true )
-
-        # Uncomment to use CMake FindBLAS using BLA_VENDOR
-        # if (NOT BLA_VENDOR)
-        #    set( BLA_VENDOR Intel10_64lp )
-        # endif()
-
-        target_compile_options( blaspp PUBLIC -fsycl )
-        target_link_options( blaspp PUBLIC -fsycl )
-        target_link_libraries( blaspp PUBLIC -lmkl_sycl -lsycl -lOpenCL )
-        message( STATUS "${blue}Building oneMKL-SYCL device support${plain}" )
-    elseif (gpu_backend STREQUAL "sycl")
-        message( FATAL_ERROR "${red}SYCL compiler not found${plain}" )
-    else()
-        message( STATUS "${red}No oneMKL-SYCL device support: oneMKL or SYCL compiler not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No oneMKL-SYCL device support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# Clean stale defines.h from Makefile-based build.
-message( "" )
