=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
         message( "" )
     else()
         set( url "https://github.com/icl-utk-edu/testsweeper" )
-        set( tag "v2024.05.31" )
+        set( tag "v2025.05.28" )
         message( "" )
         message( "---------- TestSweeper" )
         message( STATUS "Fetching TestSweeper ${tag} from ${url}" )
@@ -57,12 +57,10 @@
     test_batch_trsm.cc
     test_copy.cc
     test_dot.cc
-    test_dotu.cc
     test_error.cc
     test_gemm.cc
     test_gemv.cc
     test_ger.cc
-    test_geru.cc
     test_hemm.cc
     test_hemv.cc
     test_her.cc
@@ -102,10 +100,15 @@
     test_batch_syrk_device.cc
     test_batch_trmm_device.cc
     test_batch_trsm_device.cc
+    test_asum_device.cc
     test_axpy_device.cc
     test_dot_device.cc
-    test_dotu_device.cc
+    test_iamax_device.cc
     test_nrm2_device.cc
+    test_rot_device.cc
+    test_rotg_device.cc
+    test_rotm_device.cc
+    test_rotmg_device.cc
     test_scal_device.cc
     test_swap_device.cc
     test_copy_device.cc
