=== debian/changelog ===
blaspp (2025.05.28-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Build-Depends): Added liblapack-dev, libtestsweeper-dev and
    python3.
  * debian/rules (override_dh_auto_build): Work-around spurious link error.

 -- Michael Banck <mbanck@debian.org>  Tue, 30 Dec 2025 12:49:40 +0100
