=== debian/control ===
--- 
+++ 
@@ -5,7 +5,10 @@
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: cmake,
                debhelper (>= 11),
-               libblas-dev
+               libblas-dev,
+               liblapack-dev,
+               libtestsweeper-dev (>= 2025.05.28-1),
+               python3
 Standards-Version: 4.5.1
 Homepage: https://github.com/icl-utk-edu/blaspp
 Vcs-Browser: https://salsa.debian.org/debichem-team/blaspp
