=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,10 @@
 	dh_auto_configure -- 					\
 		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
 		-DBUILD_SHARED_LIBS=NO
+
+override_dh_auto_build:
+	-dh_auto_build
+	dh_auto_configure -- 					\
+		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
+		-DBUILD_SHARED_LIBS=NO
+	dh_auto_build
